#ifndef _DES_H
#define _DES_H

#define E_DIM 48
unsigned char E[E_DIM] = {
         32,  1,  2,  3,  4,  5,
          4,  5,  6,  7,  8,  9,
          8,  9, 10, 11, 12, 13,
         12, 13, 14, 15, 16, 17,
         16, 17, 18, 19, 20, 21,
         20, 21, 22, 23, 24, 25,
         24, 25, 26, 27, 28, 29,
         28, 29, 30, 31, 32,  1
};

#define S_BOXES    8
#define S_DIM     64
unsigned char S[S_BOXES][S_DIM] = {
       { 0xe, 0x0, 0x4, 0xf, 0xd, 0x7, 0x1, 0x4,
         0x2, 0xe, 0xf, 0x2, 0xb, 0xd, 0x8, 0x1,
         0x3, 0xa, 0xa, 0x6, 0x6, 0xc, 0xc, 0xb,
         0x5, 0x9, 0x9, 0x5, 0x0, 0x3, 0x7, 0x8,
         0x4, 0xf, 0x1, 0xc, 0xe, 0x8, 0x8, 0x2,
         0xd, 0x4, 0x6, 0x9, 0x2, 0x1, 0xb, 0x7,
         0xf, 0x5, 0xc, 0xb, 0x9, 0x3, 0x7, 0xe,
         0x3, 0xa, 0xa, 0x0, 0x5, 0x6, 0x0, 0xd
       },
       { 0xf, 0x3, 0x1, 0xd, 0x8, 0x4, 0xe, 0x7,
         0x6, 0xf, 0xb, 0x2, 0x3, 0x8, 0x4, 0xe,
         0x9, 0xc, 0x7, 0x0, 0x2, 0x1, 0xd, 0xa,
         0xc, 0x6, 0x0, 0x9, 0x5, 0xb, 0xa, 0x5,
         0x0, 0xd, 0xe, 0x8, 0x7, 0xa, 0xb, 0x1,
         0xa, 0x3, 0x4, 0xf, 0xd, 0x4, 0x1, 0x2,
         0x5, 0xb, 0x8, 0x6, 0xc, 0x7, 0x6, 0xc,
         0x9, 0x0, 0x3, 0x5, 0x2, 0xe, 0xf, 0x9
       },
       { 0xa, 0xd, 0x0, 0x7, 0x9, 0x0, 0xe, 0x9,
         0x6, 0x3, 0x3, 0x4, 0xf, 0x6, 0x5, 0xa,
         0x1, 0x2, 0xd, 0x8, 0xc, 0x5, 0x7, 0xe,
         0xb, 0xc, 0x4, 0xb, 0x2, 0xf, 0x8, 0x1,
         0xd, 0x1, 0x6, 0xa, 0x4, 0xd, 0x9, 0x0,
         0x8, 0x6, 0xf, 0x9, 0x3, 0x8, 0x0, 0x7,
         0xb, 0x4, 0x1, 0xf, 0x2, 0xe, 0xc, 0x3,
         0x5, 0xb, 0xa, 0x5, 0xe, 0x2, 0x7, 0xc
       },
       { 0x7, 0xd, 0xd, 0x8, 0xe, 0xb, 0x3, 0x5,
         0x0, 0x6, 0x6, 0xf, 0x9, 0x0, 0xa, 0x3,
         0x1, 0x4, 0x2, 0x7, 0x8, 0x2, 0x5, 0xc,
         0xb, 0x1, 0xc, 0xa, 0x4, 0xe, 0xf, 0x9,
         0xa, 0x3, 0x6, 0xf, 0x9, 0x0, 0x0, 0x6,
         0xc, 0xa, 0xb, 0x1, 0x7, 0xd, 0xd, 0x8,
         0xf, 0x9, 0x1, 0x4, 0x3, 0x5, 0xe, 0xb,
         0x5, 0xc, 0x2, 0x7, 0x8, 0x2, 0x4, 0xe
       },
       { 0x2, 0xe, 0xc, 0xb, 0x4, 0x2, 0x1, 0xc,
         0x7, 0x4, 0xa, 0x7, 0xb, 0xd, 0x6, 0x1,
         0x8, 0x5, 0x5, 0x0, 0x3, 0xf, 0xf, 0xa,
         0xd, 0x3, 0x0, 0x9, 0xe, 0x8, 0x9, 0x6,
         0x4, 0xb, 0x2, 0x8, 0x1, 0xc, 0xb, 0x7,
         0xa, 0x1, 0xd, 0xe, 0x7, 0x2, 0x8, 0xd,
         0xf, 0x6, 0x9, 0xf, 0xc, 0x0, 0x5, 0x9,
         0x6, 0xa, 0x3, 0x4, 0x0, 0x5, 0xe, 0x3
       },
       { 0xc, 0xa, 0x1, 0xf, 0xa, 0x4, 0xf, 0x2,
         0x9, 0x7, 0x2, 0xc, 0x6, 0x9, 0x8, 0x5,
         0x0, 0x6, 0xd, 0x1, 0x3, 0xd, 0x4, 0xe,
         0xe, 0x0, 0x7, 0xb, 0x5, 0x3, 0xb, 0x8,
         0x9, 0x4, 0xe, 0x3, 0xf, 0x2, 0x5, 0xc,
         0x2, 0x9, 0x8, 0x5, 0xc, 0xf, 0x3, 0xa,
         0x7, 0xb, 0x0, 0xe, 0x4, 0x1, 0xa, 0x7,
         0x1, 0x6, 0xd, 0x0, 0xb, 0x8, 0x6, 0xd
       },
       { 0x4, 0xd, 0xb, 0x0, 0x2, 0xb, 0xe, 0x7,
         0xf, 0x4, 0x0, 0x9, 0x8, 0x1, 0xd, 0xa,
         0x3, 0xe, 0xc, 0x3, 0x9, 0x5, 0x7, 0xc,
         0x5, 0x2, 0xa, 0xf, 0x6, 0x8, 0x1, 0x6,
         0x1, 0x6, 0x4, 0xb, 0xb, 0xd, 0xd, 0x8,
         0xc, 0x1, 0x3, 0x4, 0x7, 0xa, 0xe, 0x7,
         0xa, 0x9, 0xf, 0x5, 0x6, 0x0, 0x8, 0xf,
         0x0, 0xe, 0x5, 0x2, 0x9, 0x3, 0x2, 0xc
       },
       { 0xd, 0x1, 0x2, 0xf, 0x8, 0xd, 0x4, 0x8,
         0x6, 0xa, 0xf, 0x3, 0xb, 0x7, 0x1, 0x4,
         0xa, 0xc, 0x9, 0x5, 0x3, 0x6, 0xe, 0xb,
         0x5, 0x0, 0x0, 0xe, 0xc, 0x9, 0x7, 0x2,
         0x7, 0x2, 0xb, 0x1, 0x4, 0xe, 0x1, 0x7,
         0x9, 0x4, 0xc, 0xa, 0xe, 0x8, 0x2, 0xd,
         0x0, 0xf, 0x6, 0xc, 0xa, 0x9, 0xd, 0x0,
         0xf, 0x3, 0x3, 0x5, 0x5, 0x6, 0x8, 0xb
       }
};

#define P_DIM    32
unsigned char	P[P_DIM] = {
         16,  7, 20, 21,
         29, 12, 28, 17,
          1, 15, 23, 26,
          5, 18, 31, 10,
          2,  8, 24, 14,
         32, 27,  3,  9,
         19, 13, 30,  6,
         22, 11,  4, 25
         };

#define PC2_DIM 48
unsigned char	PC2[PC2_DIM] = {
         14, 17, 11, 24,  1,  5,
          3, 28, 15,  6, 21, 10,
         23, 19, 12,  4, 26,  8,
         16,  7, 27, 20, 13,  2,
         41, 52, 31, 37, 47, 55,
         30, 40, 51, 45, 33, 48,
         44, 49, 39, 56, 34, 53,
         46, 42, 50, 36, 29, 32
};

#define LS_DIM 16
unsigned char	LS[LS_DIM] = {1, 1, 2, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 2, 1};

#endif